using System;
using System.Configuration;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;
using System.IO;
using System.Net;
using System.Web.SessionState;
using System.Web.Security;
using System.Security.Cryptography.X509Certificates;
using talweg.Utils;

namespace talweg.Login
{
	public class Cas : System.Web.UI.Page
	{
		private void Page_Load(object sender, System.EventArgs e){
			//if(Session["UserName"]!=null)Response.Redirect(Request.ApplicationPath);
	    if(Request.Params["ticket"] == null){
					if(Request.Params["ReturnUrl"]!=null)Session["ReturnUrl"]=Request.Params["ReturnUrl"];
					Response.Redirect(Url.ParseUrl(ConfigurationSettings.AppSettings["CASUrl"],ConfigurationSettings.AppSettings["TalwegSuffix"])
									+"index.jsp?service="+Request.Url.Scheme+"://"+Request.Url.Authority+Request.Url.AbsolutePath);
			}
			if(Request.Params["ticket"] != null){
					if(Request.Params["ReturnUrl"]!=null)Session["ReturnUrl"]=Request.Params["ReturnUrl"];
					if( CasLoginVerify( (string)Request.Params["ticket"] ) ){
						if(Session["ReturnUrl"]!=null){
							Response.Redirect(Session["ReturnUrl"].ToString());
						}else{
							Response.Redirect(Request.ApplicationPath);
						}
					}else{
						 Response.Redirect(Url.ParseUrl(ConfigurationSettings.AppSettings["CASUrl"],ConfigurationSettings.AppSettings["TalwegSuffix"])
	                         +"index.jsp?service="+Request.Url.Scheme+"://"+Request.Url.Authority+Request.Url.AbsolutePath);
					}
			}
		}
        override protected void OnInit(EventArgs e) {
            InitializeComponent();
            base.OnInit(e);
        }
        
		private void InitializeComponent() {
            this.Load += new System.EventHandler(this.Page_Load);
        }

		private bool CasLoginVerify(string ticket) {
        	System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatesPolicy();
        	WebClient client = new WebClient();
					client.Headers.Add ("user-agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.2; .NET CLR 1.0.3705;)");
	        string pageHtml="";
        	try{
									
            	Byte[] pageData = client.DownloadData(ConfigurationSettings.AppSettings["CASUrl"]
								+"serviceValidate?service="+Request.Url.Scheme+"://"+Request.Url.Authority+Request.Url.AbsolutePath+"&ticket="+ticket);
            	pageHtml = Encoding.ASCII.GetString(pageData);
            	if(Regex.IsMatch(pageHtml,"<cas:authenticationSuccess>")){
                	Match m = Regex.Match(pageHtml,"<cas:user>(.*?)</cas:user>");
									CreateTicket(m.Groups[1].ToString());
                	return true;
            	}else{
					throw new HttpException (403, "Forbidden."+pageHtml);
            	}
        	}catch (WebException x){
				throw new HttpException (403, "Forbidden");	
        	}
        	return false;
		}
		private void CreateTicket(string username){
			FormsAuthenticationTicket ticket = new FormsAuthenticationTicket(
				1, // Ticket version
				username, // Username associated with ticket
				DateTime.Now, // Date/time issued
				DateTime.Now.AddHours(4), // Date/time to expire
				true, // "true" for a persistent user cookie
				"", // User-data, in this case the roles
				FormsAuthentication.FormsCookiePath);// Path cookie valid for
			 	// Encrypt the cookie using the machine key for secure transport
			 	string hash = FormsAuthentication.Encrypt(ticket);
			 	HttpCookie cookie = new HttpCookie(
				FormsAuthentication.FormsCookieName, // Name of auth cookie
				hash); // Hashed ticket
				cookie.Domain=ConfigurationSettings.AppSettings["TalwegSuffix"];
		 		// Add the cookie to the list for outgoing response
			 	Response.Cookies.Add(cookie);
		}
	}
  public class TrustAllCertificatesPolicy : System.Net.ICertificatePolicy {
		public bool CheckValidationResult(ServicePoint sp, X509Certificate cert,WebRequest req, int problem){
			return true;
		}
	}
}
