using System;
using System.Configuration;
using System.Reflection;
using System.Web;
using System.Web.Security;
using System.Net;
using System.Net.Radius;
using System.Web.SessionState;
using log4net;
using log4net.Config;

[assembly: log4net.Config.DOMConfigurator(Watch=true)]

namespace talweg.Login {

	public class Ldap : System.Web.UI.Page {

  	 private static readonly string ldaphost = ConfigurationSettings.AppSettings["LdapHost"];
	   private static readonly string ldaphostport = ConfigurationSettings.AppSettings["LdapHostPort"];
  	 private static readonly string ldapcontext = ConfigurationSettings.AppSettings["LdapContext"];
		 private static readonly bool ldapssl = (ConfigurationSettings.AppSettings["LdapSslConnection"]=="1")?true:false;

	  private static readonly log4net.ILog log = log4net.LogManager.GetLogger("ldap-access");

    protected System.Web.UI.HtmlControls.HtmlInputText UserLogin;
    protected System.Web.UI.HtmlControls.HtmlInputText UserPass;
    protected System.Web.UI.WebControls.Button SubmitButton;
						
    override protected void OnInit(EventArgs e) {
	    InitializeComponent();
	    base.OnInit(e);
	  }
	  private void InitializeComponent() {
			this.SubmitButton.Click += new System.EventHandler(this.Login_Click);
		}

   public void Login_Click(Object sender, EventArgs E) {
	  try {
  	  LdapConnection LdapConn = new LdapConnection();
    	LdapConn.SecureSocketLayer = ldapssl;
	    LdapConn.Connect(ldaphost,Int32.Parse(ldaphostport));
  	  LdapConn.Bind("uid="+UserLogin.Value+","+ldapcontext,UserPass.Value);
    	CreateTicket(UserLogin.Value);
	    LdapConn.Disconnect();
  	  if(Request.Params["ReturnUrl"] != null)
        Response.Redirect(Request.Params["ReturnUrl"]);
  	} catch (LdapException ex) {
    	log.Error("Ldap exception : "+ex.ToString());
	    ErrorLabel.Text = ex.Message;
  	  ErrorLabel.Visible = true;
    	throw new HttpException(500,ex.ToString());
	  }

      CreateTicket(UserLogin.Value);
      log.Info("User " + UserLogin.Value + " connected from : " + Request.ServerVariables["REMOTE_HOST"].ToString());
      if(Request.Params["ReturnUrl"] != null) 
      Response.Redirect(Request.Params["ReturnUrl"]);
    }
  }
    private void CreateTicket(string username){
            FormsAuthenticationTicket ticket = new FormsAuthenticationTicket(
                1, // Ticket version
                username, // Username associated with ticket
                DateTime.Now, // Date/time issued
                DateTime.Now.AddHours(4), // Date/time to expire
                true, // "true" for a persistent user cookie
                "", // User-data, in this case the roles
                FormsAuthentication.FormsCookiePath);// Path cookie valid for
                // Encrypt the cookie using the machine key for secure transport
                string hash = FormsAuthentication.Encrypt(ticket);
                HttpCookie cookie = new HttpCookie(
                FormsAuthentication.FormsCookieName, // Name of auth cookie
                hash); // Hashed ticket

                cookie.Domain=ConfigurationSettings.AppSettings["TalwegSuffix"];
                // Add the cookie to the list for outgoing response
                Response.Cookies.Add(cookie);
        }
		}
}

