<%@ Import Namespace="System.Net" %>
<%@ Import Namespace="System.Net.Sockets" %>
<%@ Import Namespace="Mono.Unix" %>
<%@ Import Namespace="System.Runtime.Serialization" %>
<%@ Import Namespace="System.Runtime.Serialization.Formatters.Binary" %>
<%@ Import Namespace="talwegextended" %>
<%@ Import Namespace="talweg.talwegextended" %>

<html>

    <script language="C#" runat="server">

			private static readonly log4net.ILog log = log4net.LogManager.GetLogger("talweg");
			private static readonly talweg.talwegextended.NetworkServices networkServices = (talweg.talwegextended.NetworkServices)ConfigurationSettings.GetConfig("talwegextended");

void Page_Load(Object Src, EventArgs E ) {
  if(!IsPostBack) {
		Repeater1.DataSource = networkServices;
		Repeater1.DataBind();
  }
}

        void SubmitBtn_Click(Object Sender, EventArgs e) {
						
						try {
							Acls acl = new Acls();
							acl.username = User.Identity.Name;
							bool oneIsChecked = false;
							IPHostEntry hostInfo = null;
							IPAddress[] addresses;
							foreach(RepeaterItem item in Repeater1.Items) {
			          if(((CheckBox)item.FindControl("CheckBox")).Checked){
									oneIsChecked = true;
									NetworkService networkService = networkServices.GetNetworkService( ( (Label)item.FindControl("Label") ).Text) ;
									if ( networkService == null) continue;
									if ( networkService.IsEnable ) {
										hostInfo = Dns.GetHostByName( ( (TextBox)item.FindControl("serverTextBox") ).Text);
										addresses = hostInfo.AddressList;
									} else {
										hostInfo = Dns.GetHostByName( networkService.Server );
                    addresses = hostInfo.AddressList;
									}
									foreach ( IPAddress ipAdress in addresses) {
										IPEndPoint ep = new IPEndPoint(ipAdress,networkService.Port);
										acl.eps.Add(ep);
									}
	
								}
      				}
							if ( !oneIsChecked ) return;
							acl.address = Request.ServerVariables["REMOTE_HOST"];
							Socket s = new Socket(AddressFamily.Unix, SocketType.Stream,ProtocolType.IP);
	            UnixEndPoint uep =new UnixEndPoint("/tmp/talweg-extended-socket");
							s.Connect(uep);
							NetworkStream ns = new NetworkStream(s);
							BinaryFormatter sf = new BinaryFormatter();
        			sf.Serialize(ns,acl);
        			ns.Close();
							s.Close();
						  Label1.Text = "";

						} catch (Exception ex) {
							Label1.Text = "Bad : " + ex.Message;
							log.Error("talweg-extended : " + ex.ToString());
						}
        }

    </script>

<script language="JavaScript">
<!--
function doLoad() {
    setTimeout( "refresh()", 30*1000 );
}
function refresh() {
	var button = document.getElementById("submitButton");
	button.click();
	//document.form1.submit();
}
//-->
</script>

<head>
	<title>talweg: captive portal</title>
	<link rel="stylesheet" href="https://www.my.talweg/talweg.css" type="text/css" />
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
</head>

<body onload="doLoad()">

    <h3><font face="Verdana">Services for <%=User.Identity.Name%></font></h3>

    <form id="form1" runat="server">

		<asp:Repeater id=Repeater1 runat="server">
		<HeaderTemplate>
				<table border=1>
					<tr>
						<td><b>Service</b></td>
						<td><b>Server</b></td>
						<td><b>Port</b></td>
						<td><b>Active</b></td>
					</tr>
		</HeaderTemplate>
		<ItemTemplate>
				<tr>
					<td>
							<asp:Label id="Label" Text="<%# DataBinder.Eval(Container.DataItem, "Label") %>" runat="server"/>
					</td>
					<td>
							<asp:TextBox 
									id="serverTextBox"  
									enabled="<%# DataBinder.Eval(Container.DataItem, "IsEnable") %>" 
									text="<%# DataBinder.Eval(Container.DataItem, "Server") %>"
									runat="server"
							/>

					</td>
					<td>
							<%# DataBinder.Eval(Container.DataItem, "Port") %> 
					</td>
					<td> <asp:CheckBox id="CheckBox"  runat="server"/></td>
				</tr>
		</ItemTemplate>
		<FooterTemplate>
				</table>
		</FooterTemplate>
</asp:Repeater>
<p>
<asp:Button id="submitButton" OnClick="SubmitBtn_Click" Text="Force Submit" Runat="server"/>
<asp:Label id="Label1" Text="" runat="server"/>
</form>

</body>
</html>



